namespace sGUI

declare function AddSymbol_XHair(win as sGUIWindow ptr,PosX as integer,PosY as integer) as Gadget ptr 
declare function XHR_Actions(gad as Gadget ptr,action as integer) as integer
declare sub XHR_Draw (gad as Gadget ptr)
/'
type DRG_Data
	HitMouseX as integer
	HitMouseY as integer
end type
'/
function AddSymbol_XHair(win as sGUIWindow ptr,PosX as integer,PosY as integer) as Gadget ptr
  function=0  
  dim as Gadget ptr gad
  if win=0 then win=RootWindow
  gad=win->GadgetList->AppendNew (GadgetType)
  if gad then
    gad->parent=win
    gad->Selection=0
    gad->Activation=0
    gad->PosX=PosX
    gad->PosY=PosY
    gad->GadWidth=15
    gad->GadHeight=15
    gad->DrawBuffer->img=imagecreate(gad->GadWidth,Gad->GadHeight,0,32)'by Haubitze
    if gad->DrawBuffer->img then
      ClearBox gad->DrawBuffer->img,0,0,gad->GadWidth,gad->GadHeight
      StdFilledBox gad->DrawBuffer->img,0,6,6,3,Colors.Black,Colors.White,0'l
      StdFilledBox gad->DrawBuffer->img,9,6,6,3,Colors.Black,Colors.White,0'r
      StdFilledBox gad->DrawBuffer->img,6,0,3,6,Colors.Black,Colors.White,0'o
      StdFilledBox gad->DrawBuffer->img,6,9,3,6,Colors.Black,Colors.White,0'u
    end if    
    gad->DoDraw     =@XHR_Draw
    gad->DoAction   =@XHR_Actions
    function=gad
  end if
end function


function XHR_Actions(gad as Gadget ptr,action as integer) as integer
  function=0
  dim as sGUIWindow ptr win
  win=cast(sGUIWindow ptr, gad->parent)
  select case action     
    case GADGET_LMBHIT
      gad->xtd.drg.HitMouseX=MOUSEX - gad->PosX
      gad->xtd.drg.HitMouseY=MOUSEY - gad->PosY   
    
    case GADGET_LMBHOLD,GADGET_LMBHOLDOFF
      gad->PosX =MOUSEX - gad->xtd.drg.HitMouseX
      gad->PosY =MOUSEY - gad->xtd.drg.HitMouseY
      'Limiter Stuff
      if gad->PosX<-7 then gad->PosX=-7
			if gad->PosY<-7 then gad->PosY=-7
      if gad->PosX>win->ContentWidth-8 then gad->PosX=win->ContentWidth-8
      if gad->PosY>win->ContentHeight-8 then gad->PosY=win->ContentHeight-8      
  end select  
end function


sub XHR_Draw (gad as Gadget ptr)
end sub

end namespace
