'System Includes
#include once "fbgfx.bi"
#include once "vbcompat.bi"
using FB
namespace sGUI
#include "external\sGUIList_Custom_pt1.bi"
#include "external\sGUIList.bi"
#include "external\sGUIText.bi"
#include "external\BitmapFont.bi"
#include "external\ColorInfo.bi"
#include "sGUI_ColorStorage.bas"'bekomme ich nur dort hin :/

'Fwd Ref
type _WinGadHeader  as WinGadHeader
type _Gadget        as Gadget
type _sGUIWindow    as sGUIWindow
type _sGUIEntry     as sGUIEntry
type _sGUIImage     as sGUIImage
type _BitmapFont    as BitmapFont
type _ExtendedData  as ExtendedData

'WindowFlags
'FensterTyp
const as ulong WFLAG_IMAGE                  =2^0'Bit 1  Imagefenster
'Buttons & Menu
const as ulong WFLAG_WINDOWMENU             =2^1'Bit 2  Fenster hat ein PullDownMenu
const as ulong WFLAG_DRAGABLE               =2^2'Bit 3  Fenster ist verschiebbar
const as ulong WFLAG_CLOSEABLE              =2^3'Bit 4  Fenster hat nen CloseButton
const as ulong WFLAG_MINIMISABLE            =2^4'Bit 5  !!! Funktion noch nicht eingebaut !!! reserviert fr einen MinimalisierButton
'GFX Components
const as ulong WFLAG_FRAMED                 =2^5'Bit 6  Fenster mit Rahmen
const as ulong WFLAG_TITLEBAR               =2^6'Bit 7  Fenster mit TitelBalken
const as ulong WFLAG_MENUBAR                =2^7'Bit 8  Fenster mit MenuBalken
'Stapelverhalten
const as ulong WFLAG_STACKABLE              =2^8'Bit 9  Fenster kann sich im Fensterstapel bewegen, hngt natrlich auch von der Art der anderen Fenster ab
const as ulong WFLAG_BACKDROP               =2^9'Bit 10 Fenster ist immer im Hintergrund
const as ulong WFLAG_ALWAYSONTOP            =2^10'Bit 11 Fenster ist immer oben auf dem Fensterstapel
const as ulong WFLAG_WARN                   =2^11'Bit 12 nur dieses Fenster hat Funktionalitt, die anderen Fenster sind gesperrt
const as ulong WFLAG_WARNIGNORE             =2^12'Bit 13 !!! Funktion noch nicht eingebaut !!! Spezialflag fr DropDownGadget-Windows
'Focus
const as ulong WFLAG_PARENTSELECT           =2^13'Bit 14 bei Mausklick ins Fenster wird dessen Parent-Window selektiert
const as ulong WFLAG_NOSELECT               =2^14'Bit 15 Fenster geht nicht in den SelektionsModus und ndert auch nicht eine mglich bestehende Selektion eines anderen Fensters  
'GFX 
const as ulong WFLAG_APPEARSSELECTED        =2^15'Bit 16 unabhngig vom Mausklick, Fenster wird permanent selektiert dargestellt
const as ulong WFLAG_APPEARSUNSELECTED      =2^16'Bit 17 unabhngig vom Mausklick, Fenster wird permanent unselektiert dargestellt

const as ulong WFLAG_HIDECLICKEDOUTSIDE     =2^17'Bit 18 ein Klick ausserhalb des Fensters schliesst es, nur Klicks innerhalb hlt das Fenster geffnet
const as ulong WFLAG_HIDECLICKEDINSIDE      =2^18'Bit 19 ein Klick innerhalb des Fensters schliesst es

const as ulong WFLAG_DELETEONCLOSE          =2^19'Bit 20 wenn gesetzt wird beim Klicken auf den CloseButton das Fenster(und all dessen Childzeugs) real gelscht, vorhandene Zeiger weisen dann ins Nirwana
'nicht vergessen, bei weiteren Flags bitte ValidateFlags() in sGUI_Windows.bas anpassen

'Konstanten fr die Beschreibung des Maustastenstatus
const as integer HIT=2      'Taste grad frisch gedrckt
const as integer HOLD=3     'Taste gehalten
const as integer RELEASE=1  'Taste grad losgelassen
const as integer RELEASED=0 'Taste ist losgelassen
'Konstanten Activation
const as integer ACTIVATION_OFF=0
const as integer ACTIVATION_ON=1
const as integer ACTIVATION_SLEEP=2

'Konstanten fr die Beschreibung der Ereignisse von Controls
'Durchlufer
const as integer GADGET_LOOPTHROUGH=0    '.... mal sehen ob es funzt
'LMB
const as integer GADGET_LMBHIT=1         'Control grad frisch gedrckt
const as integer GADGET_LMBHOLD=2        'Control wird gehalten, Maus ber dem Control
const as integer GADGET_LMBHOLDOFF=3     'Control wird gehalten, Maus neben dem Control
const as integer GADGET_LMBRELEASE=4     'Control regulr losgelassen
const as integer GADGET_LMBRELEASEOFF=5  'Control losgelassen, dabei ist Maus neben dem Control
'MMB
const as integer GADGET_MMBHIT=6         'Control grad frisch gedrckt
const as integer GADGET_MMBHOLD=7        'Control wird gehalten, Maus ber dem Control
const as integer GADGET_MMBHOLDOFF=8     'Control wird gehalten, Maus neben dem Control
const as integer GADGET_MMBRELEASE=9     'Control regulr losgelassen
const as integer GADGET_MMBRELEASEOFF=10 'Control losgelassen, dabei ist Maus neben dem Control
'RMB
const as integer GADGET_RMBHIT=11        'Control grad frisch gedrckt
const as integer GADGET_RMBHOLD=12       'Control wird gehalten, Maus ber dem Control
const as integer GADGET_RMBHOLDOFF=13    'Control wird gehalten, Maus neben dem Control
const as integer GADGET_RMBRELEASE=14    'Control regulr losgelassen
const as integer GADGET_RMBRELEASEOFF=15 'Control losgelassen, dabei ist Maus neben dem Control
'Highlighting
const as integer GADGET_MOUSEHOVER=16    'Control ist losgelassen, dabei "schwebt" Maus berm dem Control
const as integer GADGET_MOUSENEXT =17    'Control ist losgelassen, dabei ist Maus jetzt neben dem Control
'Keyboard
const as integer GADGET_KEYBOARD=18    'Control verarbeitet die Tastatureingaben
const as integer GADGET_KEYBOARDOFF=19 'Abbruch der Verarbeitung der Tastatureingaben eines Controls
'Wheel
const as integer GADGET_WHEELMOVE=20  'Rad wurde bewegt

'EntryType Konstanten
const as integer ETYPE_UNDEFINED=0
const as integer ETYPE_LABEL=1
const as integer ETYPE_FILE=2
const as integer ETYPE_DIR=3
'Men
const as integer ETYPE_OPENMENUSTRIP=4
const as integer ETYPE_CLOSEMENUSTRIP=5
const as integer ETYPE_ITEM=6
const as integer ETYPE_CHECKMARK=7
const as integer ETYPE_SEPARATOR=8

'GFX Zeugs
'GUI interner Standard-Abstand,-Breite
dim shared as integer LeastGap,MainWidth
'Farben
dim shared as ColorStorage Colors
dim shared as integer HoverFX,GradientFX,FrameContrastFX
dim shared as integer BevelFX,FrameFX
'Font
dim shared as integer fontheight
dim shared as _BitmapFont ptr FontA,FontB
dim shared as integer ScrnWidth,ScrnHeight
dim shared as _sGUIImage ptr RadioButtonMask

'System Events
'Keyboard
dim shared as string  KEY,tmpkey
dim shared as integer ASCCODE
dim shared as integer EXTENDED
dim shared as integer SCANCODE
'Maus
dim shared as integer MOUSEMOVED'idea by Petan
dim shared as short MOUSEX
dim shared as short MOUSEY
dim shared as short MOUSEDELTAX
dim shared as short MOUSEDELTAY
dim shared as integer LMB
dim shared as integer MMB
dim shared as integer RMB
dim shared as integer LMB_DOUBLE_CLICK, MMB_DOUBLE_CLICK, RMB_DOUBLE_CLICK
dim shared as integer WHEEL
dim shared as integer SCREENCLOSEBUTTON

'alte Vergleichswerte, in der Regel vom vorherigen Loopdurchlauf
dim shared as short oldMOUSEX
dim shared as short oldMOUSEY
dim shared as integer LMBpressed,MMBpressed,RMBpressed
dim shared as integer oldLMB
dim shared as integer oldMMB
dim shared as integer oldRMB
dim shared as integer oldWHEEL
dim shared as integer wheelvalue,oldwheelvalue
dim shared as integer NEWCLICKSEQUENCE

'Message System
dim shared as _Gadget ptr       GADGETMESSAGE'Nummer(genauer Pointer) des Gadgets, welches nen "Ping" von sich gibt
dim shared as _sGUIWindow ptr   WINDOWMESSAGE'Nummer(genauer Pointer) des Fensters, in welchem eine GADGETMESSAGE auftrat
dim shared as integer           MENUMESSAGE'ID des Meneintrages, welcher angewhlt wurde

'Einstiegspunkt frs MCP
dim shared as _sGUIWindow ptr RootWindow'!!!
'aktueller DrawMode des MCP
dim shared as integer MCPMode

'****Listen ber Listen
dim shared as sGUIList ptr WindowLists,GadgetWindowList
dim shared as sGUIList ptr ExtendedActionList
dim shared as sGUIList ptr GadgetLists,ImageList,TextList,EntryLists,PointersLists

'sGUI Includes
#include "sGUI_Misc.bas"
#include "sGUI_ExtendedData.bas"
#include "sGUI_SystemEvents.bas"
#include "sGUI_Font.bas"
#include "sGUI_Type_sGUIImage.bas"
#include "sGUI_Type_WindowGadget.bas"
#include "sGUI_Type_sGUIEntry.bas"
#include "sGUI_Type_ExtendedAction.bas"
#include "external\sGUIList_Custom_pt2.bi"
#include "sGUI_Drawing.bas"
#include "sGUI_Screen.bas"
#include "sGUI_MCP.bas"

end namespace

sGUI.SCREENCLOSEBUTTON=0
sGUI.NEWCLICKSEQUENCE=0
sGUI.FontA=new sGUI.BitmapFont
sGUI.FontB=new sGUI.BitmapFont

sGUI.WindowLists=new sGUI.sGUIList
sGUI.GadgetWindowList=new sGUI.sGUIList
sGUI.GadgetLists=new sGUI.sGUIList
sGUI.ImageList=new sGUI.sGUIList
sGUI.TextList= new sGUI.sGUIList
sGUI.EntryLists= new sGUI.sGUIList
sGUI.PointersLists= new sGUI.sGUIList
sGUI.ExtendedActionList= new sGUI.sGUIList

#include once "sGUI_Entry.bas"
#include once "sGUI_Window.bas"
#include once "sGUI_Init.bas"
'******************************************************************************
'******************************************************************************
'allg. Destruktor**************************************************************

sub Maindestructor destructor 
  if sGUI.FontA then delete sGUI.FontA
  if sGUI.FontB then delete sGUI.FontB   
  if sGUI.WindowLists then delete sGUI.WindowLists
  if sGUI.GadgetWindowList then delete sGUI.GadgetWindowList
  if sGUI.GadgetLists then delete sGUI.GadgetLists  
  if sGUI.ImageList then delete sGUI.ImageList
  if sGUI.TextList then delete sGUI.TextList
  if sGUI.EntryLists then delete sGUI.EntryLists
	if sGUI.ExtendedActionList then delete sGUI.ExtendedActionList
  if sGUI.PointersLists then delete sGUI.PointersLists
  'beep' :)<--- it works!!! 
end sub
