'Gadget/Window Extended Data
'gad->xtd. ...  win->xtd. ...

'Window
type WND_Data
	CloseButton   as _Gadget ptr
	DragBar				as _Gadget ptr  
end type

'WindowDragBar
type DRG_Data
	HitMouseX       as integer
	HitMouseY       as integer
	ScrMoveX        as integer
	ScrMoveY        as integer  
  ScrPosX         as integer
  ScrPosY         as integer
  oldWinSelection as integer
end type

'WindowCloseButton
type WCB_Data
  oldWinSelection as integer
end type

'SimpleGadget/ToggleGadget
type BTN_Data
  Fire as integer
  UseButtonColors as integer
  GadBody as ulong
  GadText as ulong
  GadBodySelected as ulong
  GadTextSelected as ulong
  BtnWindow as _sGUIWindow ptr
end type

'Arrow
type ARR_Data
	Direction 	as integer
	DelayState 	as integer
  DelayStart  as double
end type

'Label
type LBL_Data
	TextColor as ulong
end type

'RadioButton CheckMark
type RBC_Data
	KindOf				    as integer
	OffsetXDraw	      as integer
	OffsetYDraw       as integer
	OffsetXText		    as integer
	OffsetYText		    as integer
	TextLeftRight     as integer
  Radius            as integer
  DrawSize          as integer
	RBList				    as sGUIList ptr
  RTWindow          as _sGUIWindow ptr		
end type

'DropDownListBox
type DDL_Data
	WinExternal		as _sGUIWindow ptr
	ListBox				as _Gadget ptr
  mode          as integer
end type

'ScrollBar Container
type SBC_Data
	ScrollValue 			as integer
	ScrollValueOld 		as integer
	ScrollValueMax		as integer
	ScrollValueMin		as integer
	PageSize					as integer
  SlideSize         as integer
	KnobSize					as integer
	SwitchHV					as integer
	SwitchSlideMode		as integer
	KnobMouseOffset		as integer
	KnobPosition			as integer	
end type

'ScrollBar
type SCR_Data
	ScrollValue 			as integer
	ScrollValueOld 		as integer
	knobcontainer			as _Gadget ptr
	Arrowincr					as _Gadget ptr
	Arrowdecr					as _Gadget ptr
end type

'ListBox Selector
type LBS_Data
	DisplayMode	      as integer
	SelectionMode     as integer
	NumCharsPerRow		as integer'wird nicht mehr benutzt
	NumRows						as integer
	GapHorizontal			as integer
	GapVertical				as integer
	TopRow						as integer	
	SelectedRow				as integer
  HoveredRow        as integer
  oldHoveredRow     as integer
end type

'ListBox
type LBX_Data
	DisplayMode	      as integer
	SelectionMode     as integer	
	NumEntriesRef			as integer
  TimeStamp         as double
	selector				  as _Gadget ptr
	scrollbar					as _Gadget ptr	
end type

'Edit_Display
type EDD_Data
	Mode					    as integer
	CharsPerWidth     as integer'Anzeigebezogen: Wieviel Zeichen einer Zeile passen in die Breite der pixeldefinierten Box
	RowsPerHeight     as integer'Anzeigebezogen: Wieviel Zeilen passen in die Hhe der pixeldefinerten Box
	GapHorizontal			as integer
	GapVertical				as integer
	ScrollRow					as integer
	ScrollPosition		as integer
	CursorVisibility	as integer
end type

'EditBox
type EDB_Data
	Mode					      as integer
	CharsPerWidth       as integer'PageSize horiz. Scrollbar
	RowsPerHeight				as integer'PageSize vert. Scrollbar   
  NumRows             as integer'Abgleich, bei Vernderungen im Text mu Update erfolgen
  LongestRow          as integer'"
  CursorRow           as integer'"
  CursorPos           as integer'"
  TimeStamp           as double
	edit         			  as _Gadget ptr
	vscroll 					  as _Gadget ptr
	hscroll 					  as _Gadget ptr  
end type

'String
type STG_Data
	Mode					      as integer
	CharsPerWidth       as integer
	RowsPerHeight				as integer 
  MaxChars            as integer
  CharLimitation      as integer
  ShowEnd             as integer
  Focus               as integer
  TimeStamp           as double  
	edit         			  as _Gadget ptr  
end type


'FileRequester
type FRQ_Data
  Mode					    as integer
  RequestSuccess    as integer
  Separator         as integer
  btn_doit         	as _Gadget ptr
  btn_cancel        as _Gadget ptr
  lbl_file         	as _Gadget ptr
  stg_file         	as _Gadget ptr
  lbx_content       as _Gadget ptr
  btn_parent        as _Gadget ptr
  stg_path         	as _Gadget ptr
  frqWindow         as _sGUIWindow ptr
  frqWarnWindow     as _sGUIWindow ptr
end type

'Menu Gadgets
type MNG_Data
	MenuEntry           as _sGUIEntry ptr
  ChildStripWindow    as _sGUIWindow ptr
  TimeStamp           as double  
end type

'******************************************************************************
'******************************************************************************
'******************************************************************************

type ExtendedData
	EntryList					as sGUIList ptr
  TContainer			  as sGUIText ptr
	union
    wnd as WND_data
		drg as DRG_Data
    wcb as WCB_Data
    btn as BTN_Data
		arr as ARR_Data
		lbl as LBL_Data
		rbc	as RBC_Data
		ddl	as DDL_Data
		sbc as SBC_Data
		scr as SCR_Data
		lbs as LBS_Data
		lbx as LBX_Data
		edd as EDD_Data
		edb as EDB_Data
    stg as STG_Data
    frq as FRQ_Data
    mng as MNG_Data
	end union
end type
