'
#include "sGUI\sGUI.bas"
#include once "sGUI\Gadget_ScrollBar.bas"
#include once "sGUI\Gadget_DropDownListBox.bas"
#include once "sGUI\Gadget_Label.bas"
#include once "sGUI\Gadget_SimpleToggle.bas"
#include once "sGUI\Gadget_RadioCheck.bas"
#include once "sGUI\Gadget_TextField.bas"
#include once "sGUI\Gadget_String.bas"
#include once "sGUI\Gadget_FileRequester.bas"
using sGUI

declare sub SetSliders(entry as integer)


declare sub SetColor (entry as integer) 
declare sub DrawGadgets

sGUIScreenRes 1280,800,32
InitGUI
#include "color_scheme_dark.bi"
color Colors.Pen,Colors.BackGround
cls
windowtitle "Beautifier...  a very basic color scheme editor"
LoadProportionalFont("Fonts\Ubuntu-Medium\Ubuntu-Medium.bmp")
LoadFixedFont("Fonts\Ubuntu-Medium-Mono\Ubuntu-Medium-Mono.bmp")

'ToolBox***********************************************************************
dim as sGUIWindow ptr ToolBox
'die Gadgets der Toolbox sind shared, damit die Subs SetSliders() und SetColor() auf einfachem Weg darauf zugreifen knnen
'nicht die hohe Kunst, was solls... ;)
dim shared as Gadget ptr fr,ddlColors, scrRed, scrGreen, scrBlue, scrBvl, scrGrd, scrFrame, lblRGB, lblBvl, lblGrd, lblFrame, chkhover,chkFrame, savesnippet
fr=AddFileRequester("Speichern","Abbruch")

ToolBox=AddWindow(0,430,50,340,500,"ColorSchemeToolBox",WFLAG_FRAMED or WFLAG_TITLEBAR or WFLAG_DRAGABLE or WFLAG_CLOSEABLE)

ddlColors=AddDropDownListBox(ToolBox,10,10,320,25,320,150)
  AddEntry(ddlColors,"Pen")
  AddEntry(ddlColors,"BackGround")
  AddEntry(ddlColors,"Window Frame")
  AddEntry(ddlColors,"Window Text")
  AddEntry(ddlColors,"Window Frame unselected")
  AddEntry(ddlColors,"Window Text unselected")
  AddEntry(ddlColors,"Gadget Body")
  AddEntry(ddlColors,"Gadget Text/Symbol")
  AddEntry(ddlColors,"Gadget Body selected")
  AddEntry(ddlColors,"Gadget Text/Symbol selected")
  AddEntry(ddlColors,"HoverFX")
  AddEntry(ddlColors,"HoverFX selected")
  AddEntry(ddlColors,"HoverFX Text/Symbol")
  AddEntry(ddlColors,"Sleep Mode Pattern")
  AddEntry(ddlColors,"ScrollBar Container")
  AddEntry(ddlColors,"EditBox Pen")
  AddEntry(ddlColors,"EditBox BackGround")
  AddEntry(ddlColors,"EditBox Cursor")
  AddEntry(ddlColors,"ListBox FR Dir")
  AddEntry(ddlColors,"ListBox FR File")  
  AddEntry(ddlColors,"ListBox FR selected Dir")
  AddEntry(ddlColors,"ListBox FR selected File")
  AddEntry(ddlColors,"ListBox FR Backgrnd selected")  
  SetDDListBox(ddlColors,2)'Background vorselekieren  
lblRGB=AddLabel (ToolBox,10,40,"R,G,B (hex): ")
scrRed=AddScrollBar(ToolBox,10,70,320,0,255,1,1,0)
scrGreen=AddScrollBar(ToolBox,10,100,320,0,255,1,1,0)
scrBlue=AddScrollBar(ToolBox,10,130,320,0,255,1,1,0)
chkFrame=AddCheckMarkGadget (ToolBox,10,170,"Frame FX")
lblFrame=AddLabel (ToolBox,10,200,"FrameContrastFX: " & FrameContrastFX)
scrFrame=AddScrollBar(ToolBox,10,230,320,-100,100,1,1,0)
lblBvl=AddLabel (ToolBox,10,270,"BevelFX: " & BevelFX)
scrBvl=AddScrollBar(ToolBox,10,300,320,0,100,1,1,0)
lblGrd=AddLabel (ToolBox,10,340,"GradientFX: " & GradientFX)
scrGrd=AddScrollBar(ToolBox,10,370,320,0,100,1,1,0)
chkhover=AddCheckMarkGadget (ToolBox,10,410,"Hover FX")
savesnippet=AddSimpleGadget(ToolBox,10,460,320,30,"save colors as code snippet")

if HoverFX then SetSelect(chkhover)
if FrameFX then SetSelect(chkFrame)

GadgetOn(ddlColors)
GadgetOn(scrRed)
GadgetOn(scrGreen)
GadgetOn(scrBlue)
GadgetOn(scrBvl)
GadgetOn(scrGrd)
GadgetOn(scrFrame)
GadgetOn(lblRGB)
GadgetOn(lblBvl)
GadgetOn(lblGrd)
GadgetOn(lblFrame)
GadgetOn(chkhover)
GadgetOn(chkFrame)
GadgetOn(savesnippet)

'Demoobjekte*******************************************************************

dim as sGUIWindow ptr win1
dim as Gadget ptr btn,tgl,ddl,lst,edb,tfld,btnsleep
dim as Gadget ptr rdo1,rdo2,rdo3,chk1,chk2,chk3,openWinbtn
btn=AddSimpleGadget(0,10,10,,,"Button")

tgl=AddToggleGadget(0,10,50,140,60,"Toggle")
SetSelect(tgl)
ddl=AddDropDownListBox(0,10,140,150,30,280,100,1)'mit rotierender Liste
for i as integer=1 to 10   
  AddEntry(ddl,"Entry " & i )
next i
SetDDListBox(ddl,4)
btnsleep=AddSimpleGadget(0,180,140,,,"Sleep Button")
edb=AddTextField (0,10,200,400,150)
edb->xtd.TContainer->LoadText "__Beautifier.bas"
tfld=AddStringGadget (0,10,360,300)

lst=AddListBox(0,10,500,350,90,2,2)' MultiSelect/DirectoryMode
'ein Fake-Verzeichnis erzeugen
AddEntry(lst,"Directory X",ETYPE_DIR)
AddEntry(lst,"Directory Y",ETYPE_DIR)
AddEntry(lst,"File A",ETYPE_FILE)
AddEntry(lst,"File Z",ETYPE_FILE)

rdo1=AddRadioButton (0,240,10,"Radio 1",0)
rdo2=AddRadioButton (0,240,50,"Radio 2",rdo1)
rdo3=AddRadioButton (0,240,90,"Radio 3",rdo1,1)
chk1=AddCheckMarkGadget (0,400,10,"Check 1")
chk2=AddCheckMarkGadget (0,400,50,"Check 2")
chk3=AddCheckMarkGadget (0,400,90,"Check 3",1)
openWinbtn=AddSimpleGadget (0,560,10,230,25,"Show ToolBox")

win1=AddWindow(0,10,420,350,30,"unselected Window",WFLAG_FRAMED or WFLAG_TITLEBAR or WFLAG_DRAGABLE or _
                WFLAG_STACKABLE or WFLAG_APPEARSUNSELECTED)
ShowWindow(win1)

GadgetOn(btn)
GadgetOn(tgl)
GadgetOn(ddl)
GadgetOn(lst)
GadgetOn(edb)
GadgetOn(tfld)
GadgetSleep(btnsleep)
GadgetOn(rdo1)
GadgetOn(rdo2)
GadgetOn(rdo3)
GadgetOn(chk1)
GadgetOn(chk2)
GadgetOn(chk3)
GadgetOn(openWinbtn)

SetLabelColor(lblRGB,Colors.Pen)
SetLabelColor(lblBvl,Colors.Pen )
SetLabelColor(lblGrd,Colors.Pen )
SetLabelColor(lblFrame,Colors.Pen )

ShowWindow(ToolBox)

'******************************************************************************
dim as single rad=0
dim as string filename

'DDBox u. Slider der ToolBox auf Gagdet Body
SetDDListBox(ddlColors,7)
SetSliders(7)

do
  sleep 1
  MasterControlProgram '0'0=gfx am Ende via DrawScreen
  if GADGETMESSAGE then
    select case GADGETMESSAGE
      case ddlColors
        SetSliders(GetDDListBox(ddlColors))
        DrawGadgets'siehe unten
        
      case scrRed,scrGreen,scrBlue
        SetColor(GetDDListBox(ddlColors))
        SetLabelColor(lblRGB,Colors.Pen )
        SetLabelColor(lblBvl,Colors.Pen )         
        SetLabelColor(lblGrd,Colors.Pen )
        DrawGadgets'siehe unten
        
      case chkhover
        HoverFX=iif(GetSelect(chkhover)=1,1,0)
        
        'normalerweise sollte das Highlight Handling nicht whrend der Laufzeit aus und eingeschaltet werden!
        'Da wir dies hier nun aber tun, und die CheckBox ist beim Abschalten highlighted, kommt es in ihr zu einem Grafikfehler.      
        'darum dieser kleine Hack hier:
        if GetSelect(chkhover)=0 then chkhover->MouseHover=0
        DrawGadgets'siehe unten

      case chkFrame
        FrameFX=iif(GetSelect(chkFrame)=1,1,0)
        DrawGadgets'siehe unten        
        
        
      case scrBvl
        BevelFX=GetScrollBar(scrBvl)
        SetLabelText(lblBvl, "BevelFX: " & BevelFX)
        DrawGadgets'siehe unten
        
      case scrGrd
        GradientFX=GetScrollBar(scrGrd)
        SetLabelText(lblGrd, "GradientFX: " & GradientFX)
        DrawGadgets'siehe unten
      
      case scrFrame
        FrameContrastFX=GetScrollBar(scrFrame)
        SetLabelText(lblFrame, "FrameContrastFX: " & FrameContrastFX)
        DrawGadgets'siehe unten         
        
      case savesnippet       
        filename=OpenFileRequester(fr,,"color_scheme.bi")
        if filename<>"" then
        dim as integer ff=freefile
          open filename for output as ff
            print #ff,"'snippet start*************"
            print #ff,"'insert/include this snippet right after the InitGUI command in your code"        
            print #ff,"'or open sGUI\sGUI_Init.bas and replace the code in InitGUI sub routine"          
            
            print #ff,"FrameFX=" & FrameFX            
            print #ff,"BevelFX=" & BevelFX
            print #ff,"FrameContrastFX=" & FrameContrastFX           
            
            print #ff,"GradientFX=" & GradientFX
            print #ff,"HoverFX=" & HoverFX

            print #ff,"Colors.Pen=&H" & right("000000" & hex(Colors.Pen),6)
            print #ff,"Colors.BackGround=&H" & right("000000" & hex(Colors.BackGround),6)      
            print #ff,"Colors.WinFrame=&H" & right("000000" & hex(Colors.WinFrame),6)
            print #ff,"Colors.WinText=&H" & right("000000" & hex(Colors.WinText),6)
            print #ff,"Colors.WinFrameUnselected=&H" & right("000000" & hex(Colors.WinFrameUnselected),6)
            print #ff,"Colors.WinTextUnselected=&H" & right("000000" & hex(Colors.WinTextUnselected),6)
            print #ff,"Colors.GadBody=&H" & right("000000" & hex(Colors.GadBody),6)
            print #ff,"Colors.GadText=&H" & right("000000" & hex(Colors.GadText),6)      
            print #ff,"Colors.GadBodySelected=&H" & right("000000" & hex(Colors.GadBodySelected),6)
            print #ff,"Colors.GadTextSelected=&H" & right("000000" & hex(Colors.GadTextSelected),6)
            print #ff,"Colors.HoverFX=&H" & right("000000" & hex(Colors.HoverFX),6)
            print #ff,"Colors.HoverFXSelected=&H" & right("000000" & hex(Colors.HoverFXSelected),6)            
            print #ff,"Colors.HoverFXText=&H" & right("000000" & hex(Colors.HoverFXText),6)          
            print #ff,"Colors.GadSleepPattern=&H" & right("000000" & hex(Colors.GadSleepPattern),6)         
            print #ff,"Colors.SCR_Container=&H" & right("000000" & hex(Colors.SCR_Container),6)
            print #ff,"Colors.EBX_Pen=&H" & right("000000" & hex(Colors.EBX_Pen),6)          
            print #ff,"Colors.EBX_BackGround=&H" & right("000000" & hex(Colors.EBX_BackGround),6)
            print #ff,"Colors.EBX_Cursor=&H" & right("000000" & hex(Colors.EBX_Cursor),6)           
            print #ff,"Colors.LBX_DirUnselected=&H" & right("000000" & hex(Colors.LBX_DirUnselected),6)
            print #ff,"Colors.LBX_FileUnselected=&H" & right("000000" & hex(Colors.LBX_FileUnselected),6)            
            print #ff,"Colors.LBX_DirSelected=&H" & right("000000" & hex(Colors.LBX_DirSelected),6)                 
            print #ff,"Colors.LBX_FileSelected=&H" & right("000000" & hex(Colors.LBX_FileSelected),6)
            print #ff,"Colors.LBX_BackgroundSelected=&H" & right("000000" & hex(Colors.LBX_BackgroundSelected),6)         
            print #ff,"'snippet end*************"          
          close ff        
        end if        
        
      case openWinbtn
        ShowWindow(ToolBox)
        ShowWindow(win1)
    end select
  end if
  'DrawScreen
  
loop until SCREENCLOSEBUTTON


sub SetSliders(entry as integer)
  dim as ulong col
  
  select case entry
    case 1
      col=Colors.Pen
    case 2
      col=Colors.BackGround      
    case 3
      col=Colors.WinFrame
    case 4
      col=Colors.WinText
    case 5
      col=Colors.WinFrameUnselected
    case 6
      col=Colors.WinTextUnselected
    case 7
      col=Colors.GadBody
    case 8
      col=Colors.GadText      
    case 9
      col=Colors.GadBodySelected
    case 10
      col=Colors.GadTextSelected
    case 11
      col=Colors.HoverFX
    case 12
      col=Colors.HoverFXSelected      
    case 13
      col=Colors.HoverFXText        
    case 14
      col=Colors.GadSleepPattern  
    case 15
      col=Colors.SCR_Container
    case 16
      col=Colors.EBX_Pen   
    case 17
      col=Colors.EBX_BackGround
    case 18
      col=Colors.EBX_Cursor
    case 19
      col=Colors.LBX_DirUnselected
    case 20
      col=Colors.LBX_FileUnselected    
    case 21
      col=Colors.LBX_DirSelected    
    case 22
      col=Colors.LBX_FileSelected    
    case 23
      col=Colors.LBX_BackgroundSelected    
  end select
 
  SetScrollBar (scrRed,(col and &HFF0000) shr 16)
  SetScrollBar (scrGreen,(col and &HFF00) shr 8)
  SetScrollBar (scrBlue,(col and &HFF))
  SetScrollBar (scrBvl,BevelFX)
  SetScrollBar (scrGrd,GradientFX)
  SetScrollBar (scrFrame,FrameContrastFX)  
  SetLabelText(lblRGB, "R,G,B (hex): "  & right("000000" & hex(col),6) )
  SetLabelText(lblBvl, "BevelFX: " & BevelFX)
  SetLabelText(lblGrd, "GradientFX: " & GradientFX)
  SetLabelText(lblFrame, "FrameContrastFX: " & FrameContrastFX)  
end sub


sub SetColor (entry as integer)
  dim as ulong col=(GetScrollBar(scrRed) shl 16) or (GetScrollBar(scrGreen) shl 8) or GetScrollBar(scrBlue) 
  SetLabelColor(lblRGB,Colors.Pen)
  SetLabelColor(lblBvl,Colors.Pen )
  SetLabelColor(lblGrd,Colors.Pen )
  SetLabelColor(lblFrame,Colors.Pen )
  SetLabelText(lblRGB, "R,G,B (hex): " & right("000000" & hex(col),6) )  
  
  select case entry
    case 1
      Colors.Pen=col
    case 2
      Colors.BackGround=col      
    case 3
      Colors.WinFrame=col
    case 4
      Colors.WinText=col
    case 5
      Colors.WinFrameUnselected=col
    case 6
      Colors.WinTextUnselected=col
    case 7
      Colors.GadBody=col
    case 8
      Colors.GadText=col      
    case 9
      Colors.GadBodySelected=col
    case 10
      Colors.GadTextSelected=col
    case 11
      Colors.HoverFX=col
    case 12
      Colors.HoverFXSelected=col      
    case 13
      Colors.HoverFXText=col 
    case 14
      Colors.GadSleepPattern=col    
    case 15
      Colors.SCR_Container=col
    case 16
      Colors.EBX_Pen=col        
    case 17
      Colors.EBX_BackGround=col
    case 18
      Colors.EBX_Cursor=col
    case 19
      Colors.LBX_DirUnselected=col
    case 20
      Colors.LBX_FileUnselected=col    
    case 21
      Colors.LBX_DirSelected=col    
    case 22
      Colors.LBX_FileSelected=col    
    case 23
      Colors.LBX_BackgroundSelected=col         
  end select
  
  color Colors.Pen,Colors.BackGround
  cls  
end sub


'um die Prozessorlast zu verringern werden Gadgets nicht permanent, sondern nur bei Vernderungen neu gezeichnet.
'Das Verndern der RGB Werte der Pens gehrt nicht zu den Ereignissen, die ein Neuzeichnen auslsen,
'da die "sGUI-Palette" normalerweise fest definiert ist. 
'Darum erzwingen wir ausnahmsweise das Neuzeichnen der Gadgets mit Hilfe von Brechstange und dieser kleinen SUB hier.
'Dadurch steigt die Prozessorlast natrlich wieder und es kann bei etwas schmalbrstig ausgestatteten Rechnern
'zu Verzgerungseffekten kommen:
sub DrawGadgets
  dim as sGUIList ptr lst
  dim as Gadget ptr gad
  'folgende Zeile einfach so hinnehmen XD... 
  DrawRBMask(RadioButtonMask->img,MainWidth, int( iif(MainWidth mod 2,MainWidth,MainWidth-1) /2))
  lst=GadgetLists->GetFirst
  if lst then
    do
      gad=lst->GetFirst
      if gad then
        do
          gad->DoDraw (gad)'DrawGadget(gad)
          gad=cast(Gadget ptr,gad->next_node)
        loop until gad=0
      end if
      lst=cast(sGUIList ptr,lst->next_node)
    loop until lst=0
  end if 
end sub
