#include once "Gadget_ParentBtn.bas"
#include once "Gadget_SimpleToggle.bas"
#include once "Gadget_Label.bas"
#include once "Gadget_String.bas"
#include once "Gadget_ListBox.bas"

namespace sGUI

declare function AddFileRequester (doit as string="doit", cancel as string="cancel", Mode as integer=0) as Gadget ptr
declare sub FRQ_ExtendedAction (xaction as ExtendedAction ptr)
declare function FRQ_Actions(gad as Gadget ptr,action as integer) as integer

declare sub ShowFileRequester (gad as Gadget ptr,Path as string="",Filename as string="")
declare function OpenFileRequester(gad as Gadget ptr,Path as string=curdir,File as string="") as string

function AddFileRequester (doit as string="doit", cancel as string="cancel", Mode as integer=0) as Gadget ptr
  function=0  
  dim as Gadget ptr gad
  dim as sGUIWindow ptr win,wwin
  dim as ExtendedAction ptr xaction
  dim as integer heightrun
  'Gesamthhe Fenster
  heightrun= 5*10' 2xSpace to Window Border, 3xGadget Space
  heightrun += 2*GetFontHeight(1) + 4*LeastGap' 2 x StringGadget
  heightrun += 285'ListBox
  heightrun += GetFontHeight+2*LeastGap'Button Row

  win=AddWindow(0,20,20,400,heightrun,doit,WFLAG_FRAMED or WFLAG_TITLEBAR or WFLAG_DRAGABLE or WFLAG_WARN or WFLAG_CLOSEABLE)
  
  gad=win->GadgetList->AppendNew (GadgetType)
  if gad then
    gad->parent=win
    gad->Selection=0
    gad->Activation=1
    gad->PosX=0
    gad->PosY=0
    gad->GadWidth=400
    gad->GadHeight=heightrun
  
    gad->GadgetWindow=AddWindow(gad,0,0,gad->GadWidth,gad->GadHeight)  
    if gad->GadgetWindow then
      gad->GadgetWindow->Activation=1
      gad->GadgetWindow->Selection=1
      
      'Windows Variante
      #ifdef __fb_win32__
        gad->xtd.frq.Separator=asc("\")
      #endif
      'Tux Variante
      #ifdef __FB_LINUX__
        gad->xtd.frq.Separator=asc("/")
      #endif       
      
      heightrun=10
      gad->xtd.frq.btn_parent=AddParentBtn(gad->GadgetWindow,10,heightrun,25,GetFontHeight(1) + 2*LeastGap)      
      gad->xtd.frq.stg_path=AddStringGadget(gad->GadgetWindow,40,heightrun,350,,,1)'nach Return wird Stringende angezeigt
      
      heightrun += 10 + GetFontHeight(1) + 2*LeastGap
      gad->xtd.frq.lbx_content=AddListBox(gad->GadgetWindow,10,heightrun,380,285,2)'DisplayMode 2= Directory Darstellung      
        wwin=AddSimpleWarnWindow(0,0,"Path and/or file not valid")
      
      heightrun += 10 + 285
      gad->xtd.frq.lbl_file=AddLabel(gad->GadgetWindow,10,heightrun,"File:")      
      gad->xtd.frq.stg_file=AddStringGadget(gad->GadgetWindow,60,heightrun,330)      
      
      heightrun += 10 + GetFontHeight(1) + 2*LeastGap   
      gad->xtd.frq.btn_doit=AddSimpleGadget(gad->GadgetWindow,130,heightrun,125,0,doit)
      gad->xtd.frq.btn_cancel=AddSimpleGadget(gad->GadgetWindow,265,heightrun,125,0,cancel)
         
      gad->xtd.frq.Mode=Mode
      gad->xtd.frq.frqWindow=win
      gad->xtd.frq.frqWarnWindow=wwin      
      gad->DoAction   =@FRQ_Actions
 
      GadgetOn(gad->xtd.frq.btn_doit)
      GadgetOn(gad->xtd.frq.btn_cancel)
      GadgetOn(gad->xtd.frq.lbl_file)
      GadgetOn(gad->xtd.frq.stg_file)
      GadgetOn(gad->xtd.frq.lbx_content)
      GadgetOn(gad->xtd.frq.btn_parent)
      GadgetOn(gad->xtd.frq.stg_path)    
 
      SetString(gad->xtd.frq.stg_path,curdir)
      DirToListBox gad->xtd.frq.lbx_content, GetString(gad->xtd.frq.stg_path)
      
      xaction=ExtendedActionList->AppendNew (ExtendedActionType)
      if xaction then
        xaction->cause_win				=win				
        xaction->DoExtendedAction	=@FRQ_ExtendedAction
        xaction->effect_gad			  =gad
      end if      
      
      function=gad
    end if
  end if
end function


sub FRQ_ExtendedAction (xaction as ExtendedAction ptr)
  dim as sGUIWindow ptr win
  dim as Gadget ptr gad
	win=xaction->cause_win
	gad=xaction->effect_gad
  if win->Activation=0 then GADGETMESSAGE=gad
end sub


function FRQ_Actions(gad as Gadget ptr,action as integer) as integer
  function=0
  dim as string full
  dim as integer ox,oy
  select case action
    case GADGET_LOOPTHROUGH
      if GADGETMESSAGE then      

        select case GADGETMESSAGE
          case gad->xtd.frq.btn_parent
            chdir ".."   
            SetString(gad->xtd.frq.stg_path,curdir)
            DirToListBox gad->xtd.frq.lbx_content, GetString(gad->xtd.frq.stg_path)        
        
          case gad->xtd.frq.stg_path
            chdir GetString(gad->xtd.frq.stg_path)   
            SetString(gad->xtd.frq.stg_path,curdir)
            DirToListBox gad->xtd.frq.lbx_content, GetString(gad->xtd.frq.stg_path)         

          case gad->xtd.frq.lbx_content
            if GetListBox(gad->xtd.frq.lbx_content) then
              if GetEntryType( gad->xtd.frq.lbx_content, GetListBox(gad->xtd.frq.lbx_content) )=ETYPE_DIR then
                chdir GetEntryText(gad->xtd.frq.lbx_content,GetListBox(gad->xtd.frq.lbx_content))
                SetString(gad->xtd.frq.stg_path,curdir)
                DirToListBox gad->xtd.frq.lbx_content,GetString(gad->xtd.frq.stg_path)
              else
                SetString(gad->xtd.frq.stg_file,GetEntryText(gad->xtd.frq.lbx_content,GetListBox(gad->xtd.frq.lbx_content)))  
              end if
            end if
        
          case gad->xtd.frq.btn_doit, gad->xtd.frq.stg_file
            
            if right(GetString(gad->xtd.frq.stg_path),1)<> chr(gad->xtd.frq.Separator) then
              full= GetString(gad->xtd.frq.stg_path) & chr(gad->xtd.frq.Separator) & GetString(gad->xtd.frq.stg_file)
            else
              full= GetString(gad->xtd.frq.stg_path) & GetString(gad->xtd.frq.stg_file)
            end if
            
            if gad->xtd.frq.Mode then
              if fileexists(full) then
                gad->xtd.frq.RequestSuccess=1
                HideWindow(gad->xtd.frq.frqWindow)            
                function=1
              
              else
                'WarnFenster mittig zum FR ausrichten und anzeigen
                ox=(gad->xtd.frq.frqWindow->WinWidth - gad->xtd.frq.frqWarnWindow->WinWidth) /2
                oy=(gad->xtd.frq.frqWindow->WinHeight - gad->xtd.frq.frqWarnWindow->WinHeight) /2
                gad->xtd.frq.frqWarnWindow->PosX = gad->xtd.frq.frqWindow->PosX + ox
                gad->xtd.frq.frqWarnWindow->PosY = gad->xtd.frq.frqWindow->PosY + oy
                ShowWindow (gad->xtd.frq.frqWarnWindow)
              end if  
            
            else            
              gad->xtd.frq.RequestSuccess=1
              HideWindow(gad->xtd.frq.frqWindow)            
              function=1               
            
            end if

          case gad->xtd.frq.btn_cancel
            gad->xtd.frq.RequestSuccess=0          
            HideWindow(gad->xtd.frq.frqWindow)
            function=1
          
         end select
      end if 
     
    case GADGET_MOUSEHOVER
      gad->MouseHover=1
   
    case GADGET_MOUSENEXT
      gad->MouseHover=0
  end select
   
end function


sub ShowFileRequester (gad as Gadget ptr, Path as string="", Filename as string="")
  if path<>"" then
    chdir Path 
    SetString(gad->xtd.frq.stg_path,curdir)
    DirToListBox gad->xtd.frq.lbx_content, GetString(gad->xtd.frq.stg_path)
  end if
  if Filename<>"" then SetString(gad->xtd.frq.stg_file,Filename) 
  gad->xtd.frq.RequestSuccess=0
  ShowWindow(gad->xtd.frq.frqWindow)
end sub


function GetFileRequester (gad as Gadget ptr) as string
  dim as string full
  full=""
  if gad->xtd.frq.RequestSuccess=1 then 
    
    if right(GetString(gad->xtd.frq.stg_path),1)<> chr(gad->xtd.frq.Separator) then
      full= GetString(gad->xtd.frq.stg_path) & chr(gad->xtd.frq.Separator) & GetString(gad->xtd.frq.stg_file)
    else
      full= GetString(gad->xtd.frq.stg_path) & GetString(gad->xtd.frq.stg_file)
    end if  
   
  else
    full=""
  end if
  
  function=full
end function


function OpenFileRequester(gad as Gadget ptr,Path as string=curdir,Filename as string="") as string
  function=""
  dim as integer screencfg, exitloop
  dim as sGUIWindow ptr win
  win=cast(sGUIWindow ptr,gad->parent)
  screencfg=sGUIScreenSet'vorherigen Screenzustand speichern
  exitloop=0
  ShowFileRequester (gad,Path,Filename)  
  do
    sleep 1
    MasterControlProgram
    if GADGETMESSAGE then
      select case GADGETMESSAGE
        case gad
          function=GetFileRequester(gad)
          exitloop=1
      end select
    end if
    'das Fenster des FR-Gadgets hat einen CloseButton
    'hierber wird dessen Activation-Status berprft.
    'Sollte dieser 0 sein, wurde der CloseButton gedrckt
    'Dann !!!MUSS!!! dieser Loop auch verlassen werden:
    if win->Activation=0 then exitloop=1
  loop until exitloop
  sGUIScreenSet( (screencfg shr 4), (screencfg and &HF) )'alten Screenzustand wiederherstellen
end function

end namespace
